<?php

namespace Drupal\cmlapi\Service;

use Drupal\Component\Transliteration\PhpTransliteration;

/**
 * Class ParserProduct.
 */
class ParserProduct extends ParserBase {

  /**
   * Parse.
   */
  public function parse($cid = FALSE) {
    $data = FALSE;
    $uri = $this->cmlService->getFilePath($cid, 'import');
    if ($uri) {
      $this->xmlParserService->parseXmlFile($uri);
      $xml = $this->xmlParserService->xmlString;
      $data = $this->parceXml($xml);
    }
    return $data;
  }

  /**
   * Parce.
   */
  public function parceXml($xml) {
    $config = \Drupal::config('cmlapi.mapsettings');
    $trans = new PhpTransliteration();
    $map = $this->map('tovar-standart', 'tovar-dop');

    $this->xmlParserService->parseXmlString($xml);
    $this->xmlParserService->get('import', 'product');
    $products = $this->xmlParserService->xmlfind;
    $products = $this->xmlParserService->arrayNormalize($products);

    $result = [];
    $result['info']['catalogNotFull'] = $this->xmlParserService->xmlArray['Каталог']['@attributes']['СодержитТолькоИзменения'];
    if ($products) {
      foreach ($products as $products1c) {
        $key = $products1c['Ид'];
        $id = strstr("{$key}#", "#", TRUE);
        foreach ($map as $map_key => $map_info) {
          $name = $trans->transliterate($map_key, '');
          if (!isset($result['data'][$id]['offers'][$key])) {
            $result['data'][$id]['offers'][$key] = [];
          }
          if (isset($map_info['dst']) && $map_info['dst'] == 'offers') {
            $result['data'][$id]['offers'][$key][$name] = $this->xmlParserService->prepare($products1c, $map_key, $map_info);
          }
          else {
            $result['data'][$id]['product'][$name] = $this->xmlParserService->prepare($products1c, $map_key, $map_info);
          }
        }
      }
    }
    return $result;
  }

}
